Bug 1037717 - ERROR: Internal memory allocation error!: TCP_CHECK from keepalived balancer daemon
Summary: ERROR: Internal memory allocation error!: TCP_CHECK from keepalived balancer ...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: ocspd
Version: 19
Hardware: x86_64
OS: Linux
unspecified
unspecified
Target Milestone: ---
Assignee: Patrick Monnerat
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2013-12-03 16:21 UTC by Account closed by the user
Modified: 2013-12-16 22:56 UTC (History)
3 users (show)

Fixed In Version: ocspd-1.9.0-2.fc18
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2013-12-07 06:55:02 UTC


Attachments (Terms of Use)
ocspd configuration (10.27 KB, text/plain)
2013-12-03 16:21 UTC, Account closed by the user
no flags Details
keepalived configuration (962 bytes, text/plain)
2013-12-03 16:22 UTC, Account closed by the user
no flags Details

Description Account closed by the user 2013-12-03 16:21:26 UTC
Created attachment 832204 [details]
ocspd configuration

Version-Release number of selected component (if applicable):
ocspd-1.9.0-1.fc19.x86_64


ERROR: Internal memory allocation error!: TCP_CHECK from keepalived balancer daemon and others tcpcheck daemons.


# systemctl status ocspd

ocspd.service - OpenCA OCSP Responder
   Loaded: loaded (/usr/lib/systemd/system/ocspd.service; disabled)
   Active: inactive (dead) since Fri 2013-11-29 12:12:07 CET; 4s ago
  Process: 24932 ExecStart=/usr/sbin/ocspd -d -c /etc/ocspd/ocspd.conf $OPTIONS (code=exited, status=0/SUCCESS)
 Main PID: 24933 (code=exited, status=0/SUCCESS)
   CGroup: name=systemd:/system/ocspd.service

Nov 29 12:11:52 buho2.bichos.org ocspd[24933]: ERROR: Internal memory allocation error!
Nov 29 12:11:52 buho2.bichos.org ocspd[24933]: ERROR::Can not parse REQ
Nov 29 12:11:57 buho2.bichos.org ocspd[24933]: ERROR: Internal memory allocation error!
Nov 29 12:11:57 buho2.bichos.org ocspd[24933]: ERROR::Can not parse REQ
Nov 29 12:12:02 buho2.bichos.org ocspd[24933]: ERROR: Internal memory allocation error!
Nov 29 12:12:02 buho2.bichos.org ocspd[24933]: ERROR::Can not parse REQ
Nov 29 12:12:07 buho2.bichos.org ocspd[24933]: ERROR: Internal memory allocation error!
Nov 29 12:12:07 buho2.bichos.org ocspd[24933]: ERROR::Can not parse REQ


You can simple testing it with,(equivalent keepalived tcpcheck):
telnet IP PORT <<<EOF
example: telnet 172.16.0.111 2560 <<<EOF

Comment 1 Account closed by the user 2013-12-03 16:22:13 UTC
Created attachment 832207 [details]
keepalived configuration

Comment 2 Patrick Monnerat 2013-12-03 18:18:28 UTC
I tried to reproduce the "Internal memory allocation" error with your ocspd.conf file (only file names and of course file contents have been changed) without success.
Do you have a recipe to reproduce? Does it always occur? What was the ocsp activity (i.e.: request count, frequency, time up) before the problem occurred?
Thanks for more info.

Comment 3 Jose Luis Godoy 2013-12-04 09:50:54 UTC
Hi Patrick:

You can get this error using 'tcping' command tool, similar to 'keepalived' TCP_CHECK:

Start the service:

# systemctl start ocspd

Show status:

# systemctl status ocspd
ocspd.service - OpenCA OCSP Responder
   Loaded: loaded (/usr/lib/systemd/system/ocspd.service; enabled)
   Active: active (running) since Wed 2013-12-04 10:32:28 CET; 13s ago
  Process: 29248 ExecStart=/usr/sbin/ocspd -d -c /etc/ocspd/ocspd.conf $OPTIONS (code=exited, status=0/SUCCESS)
 Main PID: 29249 (ocspd)
   CGroup: name=systemd:/system/ocspd.service
           \u2514\u250029249 /usr/sbin/ocspd -d -c /etc/ocspd/ocspd.conf

Dec 04 10:32:27 buho1.bichos.org ocspd[29248]: OpenCA OCSPD v1.9.0 - starting.
Dec 04 10:32:28 buho1.bichos.org ocspd[29248]: CRL loaded for first_ca
Dec 04 10:32:28 buho1.bichos.org systemd[1]: Started OpenCA OCSP Responder.

No errors for now, we check the service with 'tcping' three times:

# tcping 172.16.0.111 2560 <<< this is a simple tcp check for open port.
172.16.0.111 port 2560 open.

# tcping 172.16.0.111 2560
172.16.0.111 port 2560 open.

# tcping 172.16.0.111 2560
172.16.0.111 port 2560 open.

We see the ocspd status:

# systemctl status ocspd
ocspd.service - OpenCA OCSP Responder
   Loaded: loaded (/usr/lib/systemd/system/ocspd.service; enabled)
   Active: active (running) since Wed 2013-12-04 10:32:28 CET; 13s ago
  Process: 29248 ExecStart=/usr/sbin/ocspd -d -c /etc/ocspd/ocspd.conf $OPTIONS (code=exited, status=0/SUCCESS)
 Main PID: 29249 (ocspd)
   CGroup: name=systemd:/system/ocspd.service
           \u2514\u250029249 /usr/sbin/ocspd -d -c /etc/ocspd/ocspd.conf

Dec 04 10:32:27 buho1.bichos.org ocspd[29248]: OpenCA OCSPD v1.9.0 - starting.
Dec 04 10:32:28 buho1.bichos.org ocspd[29248]: CRL loaded for first_ca
Dec 04 10:32:28 buho1.bichos.org systemd[1]: Started OpenCA OCSP Responder.
Dec 04 10:32:36 buho1.bichos.org ocspd[29249]: ERROR: Internal memory allocation error!
Dec 04 10:32:36 buho1.bichos.org ocspd[29249]: ERROR::Can not parse REQ
Dec 04 10:32:36 buho1.bichos.org ocspd[29249]: ERROR: Internal memory allocation error!
Dec 04 10:32:36 buho1.bichos.org ocspd[29249]: ERROR::Can not parse REQ
Dec 04 10:32:37 buho1.bichos.org ocspd[29249]: ERROR: Internal memory allocation error!
Dec 04 10:32:37 buho1.bichos.org ocspd[29249]: ERROR::Can not parse REQ

It shows three errors due three tcping executions, this is the same effect with keepalived tcp_check.

Thanks. Jose Luis

Comment 4 Patrick Monnerat 2013-12-04 14:44:49 UTC
@jose luis: thanks a lot: tcping did the trick, but telnet didn't.
This is related to client closing the connection before timeout and without sending the whole request. The "memory allocation error" is not real and thus can be safely ignored.

I've just produced a patched version for tests: can you try http://kojipkgs.fedoraproject.org//work/tasks/6153/6256153/ocspd-1.9.0-2.fc19.x86_64.rpm please ?

Comment 5 Jose Luis Godoy 2013-12-04 17:56:16 UTC
Hi Patrick:

We've tested the patched version you sent and it works perfectly.

Many thanks.

Jose Luis & Xose

Comment 6 Patrick Monnerat 2013-12-05 11:46:22 UTC
Thanks a lot for testing, guys.
Official update will be available soon.

Comment 7 Fedora Update System 2013-12-05 11:50:20 UTC
ocspd-1.9.0-2.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/ocspd-1.9.0-2.fc19

Comment 8 Fedora Update System 2013-12-05 11:50:34 UTC
ocspd-1.9.0-2.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/ocspd-1.9.0-2.fc18

Comment 9 Fedora Update System 2013-12-05 11:50:49 UTC
ocspd-1.9.0-2.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/ocspd-1.9.0-2.fc20

Comment 10 Fedora Update System 2013-12-05 21:28:58 UTC
Package ocspd-1.9.0-2.fc20:
* should fix your issue,
* was pushed to the Fedora 20 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing ocspd-1.9.0-2.fc20'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2013-22828/ocspd-1.9.0-2.fc20
then log in and leave karma (feedback).

Comment 11 Fedora Update System 2013-12-07 06:55:02 UTC
ocspd-1.9.0-2.fc19 has been pushed to the Fedora 19 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 12 Fedora Update System 2013-12-14 02:57:34 UTC
ocspd-1.9.0-2.fc20 has been pushed to the Fedora 20 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 13 Fedora Update System 2013-12-16 22:56:30 UTC
ocspd-1.9.0-2.fc18 has been pushed to the Fedora 18 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.